#!/bin/perl

################################################################################
# PAD Form Demo
# Copyright (c) 2000-2002 by Oliver Grahl Software Design
#
# http://www.o-grahl.de/deupad/
#
# Freeware, Verwendung auf eigene Gefahr.
# Verffentlichung oder Weitergabe nur mit Zustimmung des Autors.
################################################################################
#
# anmelden.pl
#
# Zweck:
#  bernahme von Produktdaten aus einer PAD Datei in ein Formular
# Funktionsweise:
#  - Gibt beim ersten Aufruf ein Formular zur Eingabe der PAD Url oder
#    alternativ zum manuellen Ausfuellen des Formulars aus.
#  - Nimmt nach Absenden einer PAD Url die Eintragung vor:
#  - Lese die PAD Datei von der angegebenen URL ein.
#  - Kann die Datei nicht gelesen werden, Fehlermeldung ausgeben
#  - Pruefe den Inhalt der PAD Datei
#  - Lese die Produktdaten aus der PAD Datei und trage sie in das Formular ein.
#  - Gebe das ausgefuellte Formular zur weiteren Bearbeitung zurueck
#
################################################################################

$CDIR = $ENV{'DOCUMENT_ROOT'} . '/cgi-bin/padanm';         # Siehe readme.txt !!
use lib $ENV{'DOCUMENT_ROOT'} . '/cgi-bin/padanm';         # Siehe readme.txt !!

use PadFile;


$FORM = $CDIR . '/anmelden.html';


print "Content-type: text/html\n\n";

# Lese Formularfelder ein und entnehme die Felder PADUrl und Category
&getFields();

my $padurl = $FIELDS{'PADUrl'};

my $strForm = &get_file($FORM);

# Lese PAD Datei, falls PADUrl angegeben
if ( $padurl ) {
  # Eine PADUrl wurde angegeben:
  # Erzeuge ein PadFile Objekt und lade die PAD Datei
  my $PadFile = PadFile->new();
  $PadFile->padurl($padurl);
  if ( $PadFile->readContent() ) {
    # PAD Datei konnte gelesen werden
    $FIELDS{'error'} = "PAD Datei wurde gefunden.<br>";

    # Verifiziere Feld Application_XML_File_URL
    # Das Feld muss die URL enthalten, so wie sie hier angemeldet wird.
    # Ist das nicht der Fall, schlgt das spaetere Spidern fehl.
    $field_pad_url = $PadFile->getValue("XML_DIZ_INFO", "Web_Info", "Application_URLs", "Application_XML_File_URL");
    if ( $field_pad_url ne $padurl ) {
      # Das Feld Application_XML_File_URL ist nicht mit der angemeldeten URL identisch
      # -> Keine Eintragung zulassen, Fehlermeldung ausgeben
      $FIELDS{'error'} .= "Bei dem Versuch, die PAD Datei $padurl anzumelden ist ein Fehler aufgetreten. Korrigieren Sie den Fehler und versuchen Sie es erneut.<br><br>";
      $FIELDS{'error'} .= "Fehler: Das Feld XML_DIZ_INFO/Web_Info/Application_URLs/Application_XML_File_URL in der PAD Datei enthlt die Adresse $field_pad_url, die nicht mit der anzumeldenden Adresse bereinstimmt.";
    }
    else {
      # Program Objekt mit den Daten fuellen
      $FIELDS{'title'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Info", "Program_Name");
      $FIELDS{'version'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Info", "Program_Version");
      $FIELDS{'homepage'} = $PadFile->getValue("XML_DIZ_INFO", "Web_Info", "Application_URLs", "Application_Info_URL");
      $FIELDS{'url'} = $PadFile->getValue("XML_DIZ_INFO", "Web_Info", "Download_URLs", "Primary_Download_URL");
      $FIELDS{'size'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Info", "File_Info", "File_Size_K") . " KB";

      $FIELDS{'price'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Info", "Program_Cost_Other");
      if ( $FIELDS{'price'} eq "" ) { $FIELDS{'price'} = $PadFile->getValue("XML_DIZ_INFO", "DeuPAD", "Program_Cost_EUR") . " EUR"; };
      if ( $FIELDS{'price'} eq "" ) { $FIELDS{'price'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Info", "Program_Cost_Dollars") . " USD"; };

      $FIELDS{'description'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Descriptions", "German", "Char_Desc_2000");
      if ( $FIELDS{'description'} eq "" ) { $FIELDS{'description'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Descriptions", "German", "Char_Desc_450"); };
      if ( $FIELDS{'description'} eq "" ) { $FIELDS{'description'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Descriptions", "German", "Char_Desc_250"); };
      if ( $FIELDS{'description'} eq "" ) { $FIELDS{'description'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Descriptions", "German", "Char_Desc_80"); };
      if ( $FIELDS{'description'} eq "" ) { $FIELDS{'description'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Descriptions", "German", "Char_Desc_45"); };
      if ( $FIELDS{'description'} eq "" ) { $FIELDS{'description'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Descriptions", "English", "Char_Desc_2000"); };
      if ( $FIELDS{'description'} eq "" ) { $FIELDS{'description'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Descriptions", "English", "Char_Desc_450"); };
      if ( $FIELDS{'description'} eq "" ) { $FIELDS{'description'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Descriptions", "English", "Char_Desc_250"); };
      if ( $FIELDS{'description'} eq "" ) { $FIELDS{'description'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Descriptions", "English", "Char_Desc_80"); };
      if ( $FIELDS{'description'} eq "" ) { $FIELDS{'description'} = $PadFile->getValue("XML_DIZ_INFO", "Program_Descriptions", "English", "Char_Desc_45"); };

      my $strValue = $PadFile->getValue("XML_DIZ_INFO", "Program_Info", "Program_Type");
      if ( $strValue eq "Shareware" ) { $FIELDS{'Shareware'} = "selected"; }
      if ( $strValue eq "Freeware" ) { $FIELDS{'Freeware'} = "selected"; }
      if ( $strValue eq "Crippleware" ) { $FIELDS{'Crippleware'} = "selected"; }
      if ( $strValue eq "Demo" ) { $FIELDS{'Demo'} = "selected"; }

      my $strValue = "," . $PadFile->getValue("XML_DIZ_INFO", "Program_Info", "Program_Language") . ",";
      if ( $strValue =~ /,German,/ ) { $FIELDS{'languageGerman'} = "checked"; }
      if ( $strValue =~ /,English,/ ) { $FIELDS{'languageEnglish'} = "checked"; }

      $FIELDS{'author'} = $PadFile->getValue("XML_DIZ_INFO", "Company_Info", "Company_Name");
      $FIELDS{'email'} = $PadFile->getValue("XML_DIZ_INFO", "Company_Info", "Support_Info", "General_Email");

      $FIELDS{'error'} .= "Die Programmdaten zu " . $FIELDS{'title'} . " wurden erfolgreich abgerufen. Komplettieren Sie das Formular durch Auswahl einer Kategorie und klicken Sie dann auf Programm anmelden.";
    }
  }
  else {
    # PAD Datei konnte NICHT gelesen werden, Fehlermeldung ausgeben
    $FIELDS{'error'} .= "Bei dem Versuch, die PAD Datei $padurl anzumelden ist ein Fehler aufgetreten. Korrigieren Sie den Fehler und versuchen Sie es erneut.<br><br>";
    $FIELDS{'error'} .= "Fehler: " . $PadFile->error();
  }
}


# Felder im Formular ersetzen
$strForm =~ s/<!--PADUrl-->/$FIELDS{'PADUrl'}/;
$strForm =~ s/<!--error-->/$FIELDS{'error'}/;
$strForm =~ s/<!--title-->/$FIELDS{'title'}/;
$strForm =~ s/<!--version-->/$FIELDS{'version'}/;
$strForm =~ s/<!--homepage-->/$FIELDS{'homepage'}/;
$strForm =~ s/<!--url-->/$FIELDS{'url'}/;
$strForm =~ s/<!--size-->/$FIELDS{'size'}/;
$strForm =~ s/<!--price-->/$FIELDS{'price'}/;
$strForm =~ s/<!--description-->/$FIELDS{'description'}/;
$strForm =~ s/<!--languageGerman-->/$FIELDS{'languageGerman'}/;
$strForm =~ s/<!--languageEnglish-->/$FIELDS{'languageEnglish'}/;
$strForm =~ s/<!--typeShareware-->/$FIELDS{'typeShareware'}/;
$strForm =~ s/<!--typeFreeware-->/$FIELDS{'typeFreeware'}/;
$strForm =~ s/<!--typeNagware-->/$FIELDS{'typeNagware'}/;
$strForm =~ s/<!--typeCrippleware-->/$FIELDS{'typeCrippleware'}/;
$strForm =~ s/<!--typeDemo-->/$FIELDS{'typeDemo'}/;
$strForm =~ s/<!--author-->/$FIELDS{'author'}/;
$strForm =~ s/<!--email-->/$FIELDS{'email'}/;

# HTML Formular zurueckgeben
print $strForm;



##########################################################
# Formulardaten in Hash @FIELDS einlesen                 #
##########################################################
sub getFields
{
  if ($ENV{'REQUEST_METHOD'} eq 'GET') {
    @pairs = split(/&/, $ENV{'QUERY_STRING'});
  }
  elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    @pairs = split(/&/, $buffer);
  }
  else {
    die "Request Method not allowed";
  }

  foreach $pair (@pairs) {
    ($name, $value) = split(/=/, $pair);

    $name =~ tr/+/ /;
    $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    $value =~ s/<!--(.|\n)*-->//g;

    $FIELDS{$name} = $value;
  }
}

######################################################
# Lesen einer Datei in einen String                  #
######################################################
sub get_file
{
  my $filename = shift;
  my $str = "";

  open(GETFILE, $filename) || die "Content-type: text/html\n\n Fehler beim Lesen der Datei $filename ($!).\n";
  while(<GETFILE>) { $str .= $_; }
  close(GETFILE);

  return $str;
}



